# Class VulkanViewportBoundsRange

java.lang.Object
com.io7m.jcoronado.api.VulkanViewportBoundsRange

All Implemented Interfaces:
  `VulkanViewportBoundsRangeType`

public final class VulkanViewportBoundsRange extends Object implements VulkanViewportBoundsRangeType
The inclusive range that the corners of a viewport must be contained in.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanViewportBoundsRange.Builder`
  Builds instances of type `VulkanViewportBoundsRange`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanViewportBoundsRange.Builder`
  `builder()`
  Creates a builder for `VulkanViewportBoundsRange`.
  `static VulkanViewportBoundsRange`
  `copyOf(VulkanViewportBoundsRangeType instance)`
  Creates an immutable copy of a `VulkanViewportBoundsRangeType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanViewportBoundsRange` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `minimum`, `maximum`.
  `float`
  `maximum()`
  `float`
  `minimum()`
  `static VulkanViewportBoundsRange`
  `of(float minimum, float maximum)`
  Construct a new immutable `VulkanViewportBoundsRange` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanViewportBoundsRange` with attribute values.
  `final VulkanViewportBoundsRange`
  `withMaximum(float value)`
  Copy the current immutable object by setting a value for the `maximum` attribute.
  `final VulkanViewportBoundsRange`
  `withMinimum(float value)`
  Copy the current immutable object by setting a value for the `minimum` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### minimum

    public float minimum()
    Specified by:
      `minimum` in interface `VulkanViewportBoundsRangeType`
    Returns:
      The minimum position

  - ### maximum

    public float maximum()
    Specified by:
      `maximum` in interface `VulkanViewportBoundsRangeType`
    Returns:
      The maximum position

  - ### withMinimum

    public final VulkanViewportBoundsRange withMinimum(float value)
    Copy the current immutable object by setting a value for the `minimum` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for minimum
    Returns:
      A modified copy of the `this` object

  - ### withMaximum

    public final VulkanViewportBoundsRange withMaximum(float value)
    Copy the current immutable object by setting a value for the `maximum` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximum
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanViewportBoundsRange` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `minimum`, `maximum`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanViewportBoundsRange` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanViewportBoundsRange of(float minimum, float maximum)
    Construct a new immutable `VulkanViewportBoundsRange` instance.
    Parameters:
      `minimum` - The value for the `minimum` attribute
      `maximum` - The value for the `maximum` attribute
    Returns:
      An immutable VulkanViewportBoundsRange instance

  - ### copyOf

    public static VulkanViewportBoundsRange copyOf(VulkanViewportBoundsRangeType instance)
    Creates an immutable copy of a `VulkanViewportBoundsRangeType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanViewportBoundsRange instance

  - ### builder

    public static VulkanViewportBoundsRange.Builder builder()
    Creates a builder for `VulkanViewportBoundsRange`.

         VulkanViewportBoundsRange.builder()
            .setMinimum(float) // required minimum
            .setMaximum(float) // required maximum
            .build();

    Returns:
      A new VulkanViewportBoundsRange builder